#ifndef _EEPROMUTIL_h
#define _EEPROMUTIL_h

#if defined(ARDUINO) && ARDUINO >= 100
#include "arduino.h"
#else
#include "WProgram.h"
#endif

#include <EEPROM.h>

//
// Absolute min and max eeprom addresses.
// Actual values are hardware-dependent.
//
// These values can be changed e.g. to protect
// eeprom cells outside this range.
//
const int EEPROM_MIN_ADDR = 0;
const int EEPROM_MAX_ADDR = 511;

class EepromUtil
{
public:
	void eeprom_erase_all(byte b);
	void eeprom_serial_dump_xy(int x, int y);
	void eeprom_serial_dump_column();
	void eeprom_serial_dump_table(int bytesPerRow);
	int eeprom_read_int(int i);
	boolean eeprom_is_addr_ok(int addr);
	boolean eeprom_write_bytes(int startAddr, const byte* array, int numBytes);
	boolean eeprom_read_bytes(int startAddr, byte array[], int numBytes);
	boolean eeprom_write_int(int addr, int value);
	boolean eeprom_read_int(int addr, int* value);
	void eeprom_write_long(int address, long value);
	long eeprom_read_long(long address);
	boolean eeprom_write_string(int addr, const char* string);
	boolean eeprom_read_string(int addr, char* buffer, int bufSize);

};

extern EepromUtil eepromUtil;

#endif	//_EEPROMUTIL_h