#ifndef _HPCONTROLLER_h
#define _HPCONTROLLER_h
#if defined(ARDUINO) && ARDUINO >= 100
#include "arduino.h"
#else
#include "WProgram.h"
#endif
#include "EepromUtil.h"

#define TRUE true
#define FALSE false
#define DEBUG

time_t lastDefrost;
String ntpTime = "";
String strHTML;
extern time_t utc;

//Previous values of values to reduce network traffic
bool p_onOff;
bool p_compressorState;
bool p_fanState;
bool p_valveState;
bool p_operatingMode;
int p_defrostCount = 0xff;
int p_temp_compressor = 0xff;
int p_temp_evaporator = 0xff;
int p_temp_evapmid = 0xff;
int p_temp_external = 0xff;
int p_temp_actual = 0xff;
int p_targetTemperature = 0xff;

#define ON 0
#define OFF 1
#define COOL 0
#define HEAT 1

//Heat pump control pins (Digital outputs) from PCF8574
#define COMPRESSOR	0xef		//P4
#define VALVE		0xfe		//P0
#define FAN			0xfd		//P1
#define PUMP		0xfb		//P2

#define COMPSTARTDELAY 120000		//Minimum delay time between compressor starts (for power fail/reset etc)
#define TIMEBETWEENDEFROSTS 300		//Time between successive defrost cycles

// 8574A Address 0X70
//#define PCF8574 (0x70 >>1) // 8574A addr 001
#define PCF8574 (0x40 >>1) // 8574 addr 001
#endif		//_HPCONTROLLER_h