/*
* Position 1
Machine not running difference 39 -> 46
Running no restriction difference 16 -> 23
Running -20% 22 -> 29
Running -50% 21 -> 34
Running -80% 11 -> 20
Running -100% 10 -> 18

* Position 2
Machine not running difference 34 -> 44
Machine not running difference 16 -> 26
Running no restriction difference 5 -> 17
Running -20% -2 -> 6
Running -50% 0 -> 6
Running -100% -20 -> -9

*/
#include <BME280I2C.h>
#include <Wire.h>             // Needed for legacy versions of Arduino.
/* ====  END Includes ==== */

/* ==== Global Variables ==== */
//tempOversamplingRate(tosr), humidityOversamplingRate(hosr),pressureOversamplingRate(posr), mode(mode), standbyTime(st), filter(filter),spiEnable(spiEnable)
//BME280I2C bme;                     // Default : forced mode, standby time = 1000 ms, pressure 1, temperature 1, humidity 1, filter off
//BME280I2C bme(1, 1, 1, 1, 5, 0, false, 0x76);
//BME280I2C bme1(1, 1, 1, 1, 5, 0, false, 0x77);
BME280I2C bme(1, 1, 4, 3, 1, 4, false, 0x76);
BME280I2C bme1(1, 1, 4, 3, 1, 4, false, 0x77);

bool metric = true;
#define SAMPLECOUNT 1
/* ==== END Global Variables ==== */

void setupBME() {
	if(!bme.begin(4, 5))
		DEBUG_PRINTLN("Could not find BME280I2C sensor 1!");
	else
		DEBUG_PRINTLN("BME sensor 1 ok");

	if (!bme1.begin(4, 5))
		DEBUG_PRINTLN("Could not find BME280I2C sensor 2!");
	else
		DEBUG_PRINTLN("BME sensor 2 ok");
}

void readBMSensors() {
	float temp1(NAN), hum1(NAN), pres1(NAN);
	float temp2(NAN), hum2(NAN), pres2(NAN);

	uint8_t pressureUnit(4);   // unit: B000 = Pa, B001 = hPa, B010 = Hg, B011 = atm, B100 = bar, B101 = torr, B110 = N/m^2, B111 = psi

	bme.read(pres1, temp1, hum1, pressureUnit, metric);                // Parameters: (float& pressure, float& temp, float& humidity, bool hPa = true, bool celsius = false)
	bme1.read(pres2, temp2, hum2, pressureUnit, metric);               // Parameters: (float& pressure, float& temp, float& humidity, bool hPa = true, bool celsius = false)
	float diff = (pres1) - (pres2);

	systemState.pressure = round(diff);
	systemState.humidity = hum2;
	systemState.ambientTemperature = temp2;

	printDebugFloat("Press1", pres1);
	printDebugFloat("Press2", pres2);
	printDebugFloat("Temp1", temp1);
	printDebugFloat("Temp2", temp2);
	printDebugFloat("Hum1", hum1);
	printDebugFloat("Hum2", hum2);

	DEBUG_PRINTST("Pressure Diff: %d\n", systemState.pressure);
}

void printDebugFloat(char *buf, float val) {
	char t[10] = {};
	char result[20];

	printFloat(val, t);
	sprintf(result, "%s: %s", buf, t);
	DEBUG_PRINTST("%s\n", result);
}

void printFloat(float val, char *buff) {
	char smallBuff[16];
	int val1 = (int)val;
	unsigned int val2;

	if (val < 0) {
		val2 = (int)(-100.0 * val) % 100;
	}
	else {
		val2 = (int)(100.0 * val) % 100;
	}
	sprintf(smallBuff, "%i.%02u", val1, val2);
	strcat(buff, smallBuff);
}

