//Stuff for defrost cycle
void defrostCheck() {
#define MINDEFROSTTIME	240
#define STEP1	30
#define STEP5	180			//Time from stopping defrost to restart

	char temp[10];
	int lastDefrostStep = systemState.defrostStep;

	int timeToRunDefrost = (systemState.defrostRunTime * 60) + systemState.defrostStartDelay;		//Defrost time if not overridden

	//Temperature needs to be < defrost temperature for > defrostStartDelay seconds or we cancel the defrost
	if (systemState.defrostCount < systemState.defrostStartDelay)
	{
		systemState.defrostStepCount = systemState.defrostStartDelay;
		if (TEMP_EVAPORATOR >= systemState.defrostTemperature)
		{
			DEBUG_PRINTLN("Cancel defrost");
			tmrDefrostTick.detach();
			systemState.defrostFlag = FALSE;
			systemState.defrostCount = systemState.defrostRunTime * 60;
		}
		return;
	}

	else if (systemState.defrostCount <= STEP1 + systemState.defrostStartDelay)
	{
		systemState.defrostStep = 1; //Valve + compressor + fan off
		systemState.defrostStepCount = STEP1 + systemState.defrostStartDelay;
	}
	else if (systemState.defrostCount <= timeToRunDefrost)
	{
		systemState.defrostStepCount = timeToRunDefrost;
		systemState.defrostStep = 2;	//Compressor on
							//Check minimum defrost time has been reached
		if ((TEMP_EVAPORATOR >= systemState.defrostUpperTemperature) && (systemState.defrostCount > MINDEFROSTTIME))
		{
			DEBUG_PRINTLN("Upper defrost temperature reached, cancel defrost");
			systemState.defrostCount = timeToRunDefrost;							//Cancel defrost if we have reached the programmed upper temperature
		}
	}
	else if (systemState.defrostCount <= timeToRunDefrost + STEP5)
	{
		systemState.defrostStep = 3;	//Compressor off
		systemState.defrostStepCount = timeToRunDefrost + STEP5;
	}
	else if (systemState.defrostCount <= timeToRunDefrost + STEP5 + 5)
	{
		systemState.defrostStep = 4;	//Valve + fan on
		systemState.defrostStepCount = timeToRunDefrost + STEP5 + 120;
	}
	else if (systemState.defrostCount <= timeToRunDefrost + STEP5 + 20)
	{
		systemState.defrostStepCount = timeToRunDefrost + STEP5 + 10;
		systemState.defrostStep = 5;	//Compressor on + cancel defrost
		tmrDefrostTick.detach();
		systemState.defrostFlag = FALSE;
		systemState.defrostCount = systemState.defrostRunTime * 60;
		systemState.defrostStepCount = systemState.defrostCount;
		systemState.lastDefrost = printTime(utc);								//Save the last defrost end time
		statusEvent.send(systemState.lastDefrost.c_str(), "lastDefrost");
		DEBUG_PRINTLN("Defrost ended");
	}

	if (systemState.defrostStep != lastDefrostStep)
	{
		DEBUG_PRINTST("Defrost step %d\n", systemState.defrostStep);
		sprintf(temp, "%d", systemState.defrostStep);
		statusEvent.send(temp, "defStep");
	}

	DEBUG_PRINTST("defrostCount: %d, step:%d\n", systemState.defrostCount, systemState.defrostStep);
	switch (systemState.defrostStep)
	{
	case 1:
		setRelay(COMPRESSOR, OFF);
		setRelay(VALVE, OFF);
		setRelay(FAN, OFF);
		break;
	case 2:
		setRelay(COMPRESSOR, ON);
		break;
	case 3:
		setRelay(COMPRESSOR, OFF);
		break;
	case 4:
		setRelay(FAN, ON);
		setRelay(VALVE, ON);
		break;
	case 5:
		setRelay(COMPRESSOR, ON);
		break;
	}
}

