#include <ArduinoJson.h>
#include <WiFiUdp.h>
#include "HPControllerESP.h"

IPAddress dew(192, 168, 0, 180);
unsigned int dewPort = 8888;

bool freshData;

const int PACKET_SIZE = 24;
WiFiUDP Dew;								// An UDP instance to let us send and receive packets over UDP

void getDewpoint() {
	char pBuff[PACKET_SIZE];

	memset(pBuff, 0, sizeof(pBuff));
	Dew.begin(1234);
	Dew.beginPacket(dew, dewPort);
	Dew.write("get", 3);
	Dew.endPacket();
	delay(100);
	if (Dew.parsePacket()) {
		Dew.read(pBuff, PACKET_SIZE);  // read the packet into the buffer
		DEBUG_PRINTST("Read dewpint data: %s\n", pBuff);

		char *  p = strtok(pBuff, ",");
		int i = 0;
		/* split string */
		while (p) {
			if (i == 0)
				systemState.actualRoomTemperature = atoi(p);
			if (i == 1)
				systemState.roomDewpoint = atoi(p);
			if (i == 2)
				systemState.roomHumidity = atoi(p);
			if (i == 3)
				freshData = atoi(p);
			p = strtok(NULL, ",");
			i++;
		}
	}

	DEBUG_PRINTST("Temp:%d\nHumid:%d\nDew:%d\nData is: %s\n", systemState.actualRoomTemperature, systemState.roomHumidity, systemState.roomDewpoint, (freshData == false) ? "Old" : "New");
	sendRoomJson();
}

void sendRoomJson(){
	DynamicJsonBuffer jsonBuffer;
	JsonObject& root = jsonBuffer.createObject();
	root["roomT"] = systemState.actualRoomTemperature;
	root["roomH"] = systemState.roomHumidity;
	root["roomD"] = systemState.roomDewpoint;

	String jsonString;
	root.printTo(jsonString);
	//String reply = "roomJson(" + jsonString + ");";
	statusEvent.send(jsonString.c_str(), "roomJson");
}


