//Class for reading analogue temperature sensors
#include "sensors.h"
#include "math.h"
#include "debugWeb.h"

//Constructor
//void SENSORS::sensors()
//{
//	ntcSensor[0] = 0;
//	ntcSensor[1] = 0;
//	ntcSensor[2] = 0;
//	ntcSensor[3] = 0;
//}

// Read ntc temperature sensors
void Sensors::readTemperatureSensors()
{
	int converted;

	Wire.beginTransmission(PCF8591); // wake up PCF8591
	Wire.write(0x04); // control byte - read ADC0 then auto-increment
	Wire.endTransmission(); // end tranmission
	delay(100);
	Wire.requestFrom(PCF8591, 5);
	delay(100);
	adcSensor[0] = Wire.read();
	delay(100);
	adcSensor[0] = Wire.read();
	delay(100);
	adcSensor[1] = Wire.read();
	delay(100);
	adcSensor[2] = Wire.read();
	delay(100);
	adcSensor[3] = Wire.read();
	delay(100);

	//Read from ESP analogue pin
	adcSensor[4] = 1024 - analogRead(A0);
	for (int s = 0; s < 5; s++) {
		if (s == 4) //The adc on the ESP itself
			converted = convertToTemperature(adcSensor[s], 1024.0);
		else
			converted = convertToTemperature(adcSensor[s], 255.0);

		DEBUG_PRINTST("Raw(%d) %s: %d: %d\n", s, sensorName[s], adcSensor[s], converted);
		adcSensor[s] = converted;
	}
}

///////////////////////////
// Stuff for NTC thermistor
///////////////////////////
// 666 ohms = 100C
// convertFactor - 255 for PCF8591, 1024 for Analogue pin
#define RESISTANCE 10000
int Sensors::convertToTemperature(int rawADC, double convertFactor)
{
	double Temp, tmp1;
	//long i;
	//Serial.printf("Params: rawAdc: %d, convertFactor: %d\n", rawADC, (int)convertFactor);
	//tmp1 = (convertFactor / rawADC - 1);
	//i = tmp1 * 10000;
	//Serial.print("1:");	Serial.println(i);
	//tmp1 = RESISTANCE * tmp1; //When using PCF8591
	//i = tmp1 * 10000;
	//Serial.print("2:");	Serial.println(i);
	//Temp = log(tmp1); //When using PCF8591
	//i = tmp1 * 10000;
	//Serial.print("3:");	Serial.println(i);

	Temp = log(RESISTANCE*((convertFactor / rawADC - 1))); //When using PCF8591
	Temp = 1 / (0.001129148 + (0.000234125 + (0.0000000876741 * Temp * Temp))* Temp);
	Temp = Temp - 273.15;            // Convert Kelvin to Celcius
	return (int)Temp;
}
