#ifndef _SENSORS_h
#define _SENSORS_h
#if defined(ARDUINO) && ARDUINO >= 100
#include "arduino.h"
#else
#include "WProgram.h"
#endif
#include <Wire.h>

#define PCF8591 (0x90 >> 1) // I2C bus address
#define ADC0 0x00 // control bytes for reading individual ADCs
#define ADC1 0x01
#define ADC2 0x02
#define ADC3 0x03

//Analogue sensors
#define TEMP_COMPRESSOR sensors.adcSensor[0]
#define TEMP_EVAPORATOR sensors.adcSensor[1]
#define TEMP_EXTERNAL sensors.adcSensor[2]
#define TEMP_EVAPMID sensors.adcSensor[3]
#define TEMP_ACTUAL sensors.adcSensor[4]

class Sensors
{
public:
	int adcSensor[5];
	const char * sensorName[5] = { "Compressor", "Evaporator", "External", "Evap. Mid", "Actual" };
	// Read ntc temperature sensors
	void readTemperatureSensors();
//private:
	//Convert row adc value to temperature in C
	int convertToTemperature(int rawADC, double convertFactor);
};

extern Sensors sensors;
#endif
